<?php
/*
Plugin Name: Static Entry
Plugin URI: http://flatpress.georgi.co.uk/?x=entry:entry120923-205719
Description: Allows you to include entry content in a static page
Author: Stanley
Version: 1.0
Author URI: http://paul.us2uk.eu
*/

// this tells FlatPress to load the new tags at the very beginning 
 
add_filter('init', 'plugin_staticentry_init');
 
// define function. In this case we're creating an "inc" tag
 
function plugin_staticentry_init() {
        $bbcode = plugin_bbcode_init(); //import the "global" bbcode object into current function
                                         // this way 
                                         // a) parsing is done only once, and by the official plugin
                                         // b) you create only ONE object, and therefore computation is quicker
        $bbcode->addCode (
                    'inc',  // tag name: this will go between square brackets
                    'callback_replace', // type of action: we'll use a callback function
                    'plugin_staticentry_inc', // name of the callback function
                    array('usecontent_param' => array ('default')), // supported parameters: "default" is [inc=valore]
                    'inline', // type of the tag, inline or block, etc
                    array ('listitem', 'block', 'inline', 'link'), // type of elements in which you can use this tag
                    array ()); // type of elements where this tag CAN'T go (in this case, none, so it can go everywhere)
 
    $bbcode->setCodeFlag ('inc', 'closetag', BBCODE_CLOSETAG_MUSTEXIST); // a closing tag is mandatory [/tag]
}
 
// $content is the text between the two tags, i.e. [tag]CONTAINED TEXT[/tag] $content='CONTAINED TEXT'
// $attributes is an associative array where keys are the tag properties. default is the [tagname=value] property
 
function left($str, $length) {
     return substr($str, 0, $length);
}

function right($str, $length) {
     return substr($str, -$length);
}

function plugin_staticentry_inc($action, $attributes, $content, $params, $node_object) { 
     if ($action == 'validate') {
        // not used for now
        return true;
     }

// parse the file path of the entry file from the entry url
// perhaps there's a better way but this works...

$_entryymdtime=right($content,13);   // grabs the last 13 chars
$_entryy=left($_entryymdtime,2);     // grabs the 2-digit year
$_entryym=left($_entryymdtime,4);    // grabs the 4-digit year & month
$_entrym=right($_entryym,2);         // grabs the 2-digit month

 
$file = file_get_contents(BLOG_BASEURL . "fp-content/content/" . $_entryy . "/" . $_entrym . "/entry$_entryymdtime.txt"); 

$file = str_ireplace("[more]","", $file);

$display = explode("|", $file);

if ($display[0] !== "VERSION") {

$displaytitle="1";
$displaycontent="3";

} else {

$displaytitle="3";
$displaycontent="5";

} 

    return "<h4 class=\"staticentry\">".$display[$displaytitle]."</h4>".$display[$displaycontent]; // displays the Subject as an h4 heading - use css to hide if necessary

}

/** Adds special stlye definitions into the HTML head **/
function plugin_staticentry_style() {
	echo "	<!-- staticentry plugin style -->\n";
	echo '	<link rel="stylesheet" type="text/css" href="'. plugin_geturl('staticentry') ."res/staticentry.css\" />\n";
	echo "	<!-- end of staticentry plugin style -->\n";
}

add_action('wp_head', 'plugin_staticentry_style');
?>
